<div class="header-container">
  <gp-headline [headlineTitle]="'On-Boarding Model'"></gp-headline>
  <gp-breadcrumb-navigation
    [firstNavigationLabel]="{ label: 'Home' }"
    [secondNavigationLabel]="{ label: 'On-Boarding Model', disabled: true }"
    (firstNavigationClicked)="onHomeClick()"
  ></gp-breadcrumb-navigation>
</div>
<mat-divider></mat-divider>
<div class="content">
  <div class="flex-column full-width">
    <!-- on boarding-->
    <div>
      <gp-headline
        [headlineTitle]="'ON-BOARD DOCKERIZED MODEL URI'"
      ></gp-headline>
    </div>

    <div class="flex-row full-width">
      <div class="on-boarding-form-container">
        <!-- onboarding model form-->
        <form [formGroup]="onboardingModelForm">
          <div class="on-boarding-form-layout">
            <!--model name-->
            <div class="flex-column">
              <mat-label>Model name</mat-label>
              <mat-form-field>
                <input matInput formControlName="name" />
                @if (
                  onboardingModelForm.controls["name"].errors?.["pattern"] &&
                  onboardingModelForm.controls["name"].touched
                ) {
                  <mat-error class="modal-error"
                    >Name must consist of lower case alphanumeric characters,
                    '-' or '.', and must start and end with an alphanumeric
                    character</mat-error
                  >
                }
                @if (
                  onboardingModelForm.controls["name"].errors?.["required"] &&
                  onboardingModelForm.controls["name"].touched
                ) {
                  <mat-error class="modal-error">Name is required</mat-error>
                }
                @if (
                  onboardingModelForm.get("name")?.errors?.["nameTaken"] &&
                  onboardingModelForm.controls["name"].touched
                ) {
                  <mat-hint class="modal-note green"
                    ><strong>Name already exists:</strong>
                    an incremented version will be created within the existing
                    model.
                  </mat-hint>
                }
              </mat-form-field>
            </div>
            <!--docker URI-->
            <div class="flex-column">
              <mat-label>Docker URI </mat-label>
              <mat-hint class="modal-note green"
                ><strong>Dockerhub image example:</strong>
                docker.io/myimage:latest
              </mat-hint>
              <mat-hint class="modal-note green"
                ><strong>General public registry image example:</strong>
                cicd.ai4eu-dev.eu:7444/myimage:v1
              </mat-hint>
              <mat-form-field>
                <input matInput formControlName="dockerURI" />
                @if (
                  onboardingModelForm.controls["dockerURI"].errors?.[
                    "required"
                  ] && onboardingModelForm.controls["dockerURI"].touched
                ) {
                  <mat-error class="modal-error"
                    >Docker URI is required</mat-error
                  >
                }
              </mat-form-field>
            </div>
            <!--protobuf file-->
            <div class="flex-column full-width">
              <mat-label>Upload Protobuf File </mat-label>
              <div class="upload-file-container">
                <mat-form-field>
                  <input matInput [value]="fileName" />
                  <mat-hint class="modal-note full-width no-padding">
                    Supported files type: .proto</mat-hint
                  >

                  <input
                    #fileDropRef
                    type="file"
                    id="fileInput"
                    name="fileInput"
                    (change)="selectFile($event)"
                    hidden
                    formControlName="protobufFile"
                  />
                </mat-form-field>

                <button
                  color="primary"
                  mat-raised-button
                  (click)="onClickUploadProtoBufFile()"
                >
                  Upload file
                </button>
              </div>
              @if (message !== "") {
                <span class="modal-error">.proto file is required.</span>
              }
            </div>
            <!--license profile-->
            <div class="flex-column">
              <mat-checkbox
                color="primary"
                formControlName="addLicenseProfile"
                (change)="onClickUpload($event)"
                >Add License Profile</mat-checkbox
              >
            </div>
            @if (
              onboardingModelForm.controls["addLicenseProfile"].value === true
            ) {
              <div class="flex-row full-width">
                <gp-model-details-license-profile
                  [isExistingLicenseProfile]="false"
                ></gp-model-details-license-profile>
              </div>
            }

            <div class="buttons-container">
              <button mat-raised-button (click)="resetData()">
                Reset form
              </button>
              <button
                mat-raised-button
                color="primary"
                (click)="onClickBoardModel()"
                [disabled]="!enableSubmit"
              >
                On-board model
              </button>
            </div>
          </div>
        </form>
      </div>
      <!--Later to be implemented-->
      <!--onboarding history-->
      <div></div>
    </div>
  </div>
</div>
